<div align="center">
  
<img src="https://img.alicdn.com/imgextra/i2/O1CN01kdmA7X1FVqCPcRi3L_!!6000000000493-2-tps-584-584.png" alt="Mako logo" width="160" height="160" />

# Mako 🦈

[![](https://badgen.net/npm/v/@umijs/mako)](https://www.npmjs.com/package/@umijs/mako)
[![](https://badgen.net/npm/dm/@umijs/mako)](https://www.npmjs.com/package/@umijs/mako)
[![](https://github.com/umijs/mako/actions/workflows/ci.yml/badge.svg)](https://github.com/umijs/mako/actions/workflows/ci.yml)
[![](https://badgen.net/npm/license/umi)](https://www.npmjs.com/package/@umijs/mako)


Mako `['mɑːkoʊ]` is an **extremely fast**, **production-grade** web bundler based on **Rust**. 

✨ See more at [makojs.dev](https://makojs.dev).
</div>

## Who's using Mako?

- Web App，Hybrid App, Mini Program (Partly), Low Code, Serverless in [Ant Group](https://www.antgroup.com/)
- [Ant Design](https://github.com/ant-design/ant-design/) using Mako for its website
- [Umi](https://umijs.org/) integrated Mako for its bundling
- [Dumi](https://d.umijs.org/) integrated Mako for its bundling
- [Father](https://github.com/umijs/father/) integrated Mako for its bundling

## Getting Started

Create a new mako project with the following command.

```bash
$ npm create mako
```

Check out the https://makojs.dev/ for more information.

## CONTRIBUTING

Read [CONTRIBUTING.md](./CONTRIBUTING.md).

## CHANGELOG

Read [CHANGELOG.md](./CHANGELOG.md).

## CONTACT US

Read [Feedback on makojs.dev](https://makojs.dev/docs/feedback) on joining the discussion, contacting the maintainers, and joining the mako contributors.

## CREDITS

This project is inspired by:

- [webpack](https://github.com/webpack/webpack), which inspired lots of ideas of Mako.
- [swc](https://github.com/swc-project/swc) by [@kdy1](https://github.com/kdy1), which powered the parsing, transforming and codegen of Mako.
- [farm](https://github.com/farm-fe/farm) by [@brightwu](https://github.com/wre232114), which inspired the tree shaking, plugin system and others of Mako.
- [rspack](https://github.com/web-infra-dev/rspack), which inspired the tree shaking of Mako.
- [oxc-resolver](https://github.com/oxc-project/oxc-resolver) by [@Boshen](https://github.com/Boshen) which powered the resolver of Mako.

## LICENSE

[MIT](./LICENSE)
